-- by mor2000
-- v1.2

-- diese Lua ist nur zur Anzeige und nützt Mappern und Moddern wenig bis nichts

MultiFruitViewListener = {}

function MultiFruitViewListener:loadMap(name)
	xmlFilename=g_modsDirectory.."/ZZZ_MultiFruitUtil/MultiFruitView.xml"
	local mapsModeGui = Gui:new(g_languageSuffix)
	local xmlFile = loadXMLFile("Temp", xmlFilename)
	mapsModeGui:loadGuiRec(xmlFile, "GUI", g_inGameMenu.modeGUIElements[InGameMenu.MODE_MAP_VIEWS], g_inGameMenu)
	delete(xmlFile)
	g_inGameMenu.modeGUIElements[InGameMenu.MODE_MAP_VIEWS]:updateAbsolutePosition()
end

function MultiFruitViewListener:deleteMap()
end

function MultiFruitViewListener:mouseEvent(posX, posY, isDown, isUp, button)
end

function MultiFruitViewListener:keyEvent(unicode, sym, modifier, isDown)
end

function MultiFruitViewListener:update(dt)
end

function MultiFruitViewListener:draw()
end

addModEventListener(MultiFruitViewListener)

InGameMenuUpdateGUI=InGameMenu.updateGUI

function InGameMenu:updateGUI() -- copied and reassembled from InGameMenu.lua
	InGameMenuUpdateGUI(self)
	if g_gui.currentGuiName ~= "InGameMenu" then
		return
	end
	if self.mode == InGameMenu.MODE_MAP_VIEWS then
		if self.mapView == InGameMenu.MAP_VIEW_FRUIT_TYPES then
			-- reset old view
			for _, v in pairs(self.keyColor) do
				v:setVisible(false)
			end
			for _, v in pairs(self.keyText) do
				v:setVisible(false)
			end
			self.keyBorder2:setVisible(false)
			
			local fruitCounter = 0
			for i = 0, FruitUtil.NUM_FRUITTYPES do
				local desc = FruitUtil.fruitIndexToDesc[i]
				if desc~=nil and MultiFruitUtil.mapHasFruitType(i) and desc.fruitMapColor ~= nil and fruitCounter < 24 then
					if i ~= FruitUtil.FRUITTYPE_DRYGRASS then
						self.keyColor[fruitCounter * 4 + 1].imageColor = desc.fruitMapColor
						self.keyColor[fruitCounter * 4 + 1]:setVisible(true)
						if fruitCounter < 2 then
							self.keyColor[fruitCounter * 4 + 2].imageColor = desc.fruitMapColor
							self.keyColor[fruitCounter * 4 + 2]:setVisible(true)
						end
						
						local fillType = FruitUtil.fruitTypeToFillType[i]
						local fruitName = Fillable.fillTypeIndexToDesc[fillType].nameI18N
						self.keyText[fruitCounter + 1]:setText(fruitName)
						self.keyText[fruitCounter + 1]:setVisible(true)
						
						fruitCounter = fruitCounter + 1
					end
					local ids = g_currentMission.fruits[i]
					if ids ~= nil and ids.id ~= 0 then
						setFoliageStateOverlayFruitTypeColor(self.foliageStateOverlay, ids.id, desc.fruitMapColor[1], desc.fruitMapColor[2], desc.fruitMapColor[3])
					end
				end
				if fruitCounter>=24 then
					break
				end
			end
			self.keyBorder.size[1] = 0.0345
			self.keyBorder.size[2] = 0.005 + math.min(fruitCounter,12) * 0.0455
			self.keyBorder:setPosition(0.577, 0.835 - math.min(fruitCounter,12) * 0.0455)
			
			if fruitCounter>11 then
				self.keyBorder2.size[1] = 0.0345
				self.keyBorder2.size[2] = 0.005 + (fruitCounter-12) * 0.0455
				self.keyBorder2:setPosition(0.777, 0.835 - (fruitCounter-12) * 0.0455)
				self.keyBorder2:setVisible(true)
			end
		else
			self.keyBorder2:setVisible(false)
		end
	end
	self:updateFocusLinkageSystem()
end
